#Compile Exe
#Dim All

'----------------------------------------------------------------------------------------------------------------------
'   ** Includes **
'----------------------------------------------------------------------------------------------------------------------
#Include Once "WIN32API.INC"
#Include Once "COMMCTRL.INC"
'----------------------------------------------------------------------------------------------------------------------

'----------------------------------------------------------------------------------------------------------------------
'   ** Constants **
'----------------------------------------------------------------------------------------------------------------------
%IDD_DIALOG1  =  101
%IDC_LISTBOX1 = 1001
%IDC_BUTTON1  = 1002
'----------------------------------------------------------------------------------------------------------------------

'----------------------------------------------------------------------------------------------------------------------
'   ** Declarations **
'----------------------------------------------------------------------------------------------------------------------
Declare CallBack Function ShowDIALOG1Proc()
Declare Function SampleListBox(ByVal hDlg As Dword, ByVal lID As Long, ByVal lCount As Long) As Long
Declare Function ShowDIALOG1(ByVal hParent As Dword) As Long
'----------------------------------------------------------------------------------------------------------------------

'----------------------------------------------------------------------------------------------------------------------
'   ** Main Application Entry Point **
'----------------------------------------------------------------------------------------------------------------------
Function PbMain()
	ShowDIALOG1 %HWND_DESKTOP
End Function
'----------------------------------------------------------------------------------------------------------------------

'----------------------------------------------------------------------------------------------------------------------
'   ** CallBacks **
'----------------------------------------------------------------------------------------------------------------------
CallBack Function ShowDIALOG1Proc()

	Select Case As Long Cb.Msg
		Case %WM_INITDIALOG
			' Initialization handler

		Case %WM_NCACTIVATE
			Static hWndSaveFocus As DWord
			If IsFalse Cb.WParam Then
				' Save control focus
				hWndSaveFocus = GetFocus()
			ElseIf hWndSaveFocus Then
				' Restore control focus
				SetFocus(hWndSaveFocus)
				hWndSaveFocus = 0
			End If

		Case %WM_COMMAND
			' Process control notifications
			Select Case As Long Cb.Ctl
				Case %IDC_LISTBOX1

				Case %IDC_BUTTON1
					If Cb.CtlMsg = %BN_CLICKED Or Cb.CtlMsg = 1 Then
						ReadList CB.HNDL , %IDC_LISTBOX1
					End If

			End Select
	End Select
End Function
'----------------------------------------------------------------------------------------------------------------------


'----------------------------------------------------------------------------------------------------------------------
'   **LISTBOX Sample Code **
'----------------------------------------------------------------------------------------------------------------------
Function ListBox_Add(ByVal hDlg As Dword, ByVal lID As Long, ByVal lCount As Long) As Long
	Local i As Long

	For i = 1 To lCount
		ListBox Add hDlg, lID, Using$("Test Item #", i)
	Next i

End Function
'----------------------------------------------------------------------------------------------------------------------

'----------------------------------------------------------------------------------------------------------------------
'   ** LISTBOX Sample Code **
'----------------------------------------------------------------------------------------------------------------------
Function ReadList (ByVal hDlg As Dword, ByVal lID As Long)  As Long

	Local i, lCount As Long, txt as STRING

	LISTBOX GET COUNT hDlg, lID TO lCount

	For i = 1 To lCount
		LISTBOX GET TEXT hDlg, lID , i TO txt
		? txt
	Next i

End Function
'----------------------------------------------------------------------------------------------------------------------


'----------------------------------------------------------------------------------------------------------------------
'   ** Dialogs **
'----------------------------------------------------------------------------------------------------------------------
Function ShowDIALOG1(ByVal hParent As Dword) As Long
	Local lRslt As Long

	Local hDlg  As Dword

	Dialog New hParent, "Dialog1", 511, 225, 284, 179, %WS_POPUP Or %WS_BORDER Or %WS_DLGFRAME Or %WS_CAPTION Or _
		%WS_SYSMENU Or %WS_CLIPSIBLINGS Or %WS_VISIBLE Or %DS_MODALFRAME Or %DS_3DLOOK Or %DS_NOFAILCREATE Or _
		%DS_SETFONT, %WS_EX_CONTROLPARENT Or %WS_EX_LEFT Or %WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg
	Control Add ListBox, hDlg, %IDC_LISTBOX1, , 8, 8, 268, 128
	Control Add Button,  hDlg, %IDC_BUTTON1, "ReadList", 84, 148, 112, 20

	ListBox_Add  hDlg, %IDC_LISTBOX1, 5

	Dialog Show Modal hDlg, Call ShowDIALOG1Proc To lRslt

	Function = lRslt
End Function
'----------------------------------------------------------------------------------------------------------------------

